diff -cpr transaction_guarantee.v11/src/backend/postmaster/postmaster.c transaction_guarantee.v11fix/src/backend/postmaster/postmaster.c
*** transaction_guarantee.v11/src/backend/postmaster/postmaster.c	Tue Apr 10 19:55:56 2007
--- transaction_guarantee.v11fix/src/backend/postmaster/postmaster.c	Tue Apr 10 19:56:08 2007
*************** SubPostmasterMain(int argc, char *argv[]
*** 3400,3405 ****
--- 3400,3406 ----
  	if (strcmp(argv[1], "--forkbackend") == 0 ||
  		strcmp(argv[1], "--forkavlauncher") == 0 ||
  		strcmp(argv[1], "--forkavworker") == 0 ||
+ 		strcmp(argv[1], "--forkwalwriter") == 0 ||
  		strcmp(argv[1], "--forkboot") == 0)
  		PGSharedMemoryReAttach();
  
diff -cpr transaction_guarantee.v11/src/include/access/gist_private.h transaction_guarantee.v11fix/src/include/access/gist_private.h
*** transaction_guarantee.v11/src/include/access/gist_private.h	Mon Jan 22 13:08:11 2007
--- transaction_guarantee.v11fix/src/include/access/gist_private.h	Tue Apr 10 19:56:08 2007
*************** typedef struct GistSplitVector
*** 200,207 ****
  								 * distributed between left and right pages */
  } GistSplitVector;
  
- #define XLogRecPtrIsInvalid( r )	( (r).xlogid == 0 && (r).xrecoff == 0 )
- 
  typedef struct
  {
  	Relation	r;
--- 200,205 ----
diff -cpr transaction_guarantee.v11/src/include/access/xlogdefs.h transaction_guarantee.v11fix/src/include/access/xlogdefs.h
*** transaction_guarantee.v11/src/include/access/xlogdefs.h	Tue Apr 10 19:55:56 2007
--- transaction_guarantee.v11fix/src/include/access/xlogdefs.h	Tue Apr 10 19:56:08 2007
*************** typedef struct XLogRecPtr
*** 33,40 ****
  	uint32		xrecoff;		/* byte offset of location in log file */
  } XLogRecPtr;
  
! #define XLogRecPtrIsInvalid(p) \
! 			(((p).xlogid == 0 && (p).xrecoff == 0) ? true : false)
  
  /*
   * Macros for comparing XLogRecPtrs
--- 33,39 ----
  	uint32		xrecoff;		/* byte offset of location in log file */
  } XLogRecPtr;
  
! #define XLogRecPtrIsInvalid(r)	((r).xlogid == 0 && (r).xrecoff == 0)
  
  /*
   * Macros for comparing XLogRecPtrs
diff -cpr transaction_guarantee.v11/src/include/postmaster/walwriter.h transaction_guarantee.v11fix/src/include/postmaster/walwriter.h
*** transaction_guarantee.v11/src/include/postmaster/walwriter.h	Thu Mar 29 21:30:37 2007
--- transaction_guarantee.v11fix/src/include/postmaster/walwriter.h	Tue Apr 10 19:58:12 2007
*************** extern int WALWriterDelay;
*** 16,18 ****
--- 16,22 ----
  #define WALWriterActive() (WALWriterDelay > 0)
  
  extern int StartWALWriter(void);
+ 
+ #ifdef EXEC_BACKEND
+ extern void WALWriterMain(int argc, char *argv[]);
+ #endif